install 12 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470
  1. #!/bin/bash
  2. #################################################################
  3. # auto-mediawiki #
  4. # Instala un servidor LAMP (Linux+Apache+MySQL+PHP) e instala #
  5. # MediaWiki y lo configura. #
  6. # #
  7. # Guzman Castanedo Villalba (guzman@castanedo.es) Junio 2018 #
  8. # GPLv3 (https://www.gnu.org/licenses/gpl.html) #
  9. #################################################################
  10. OSInfo() {
  11. #printf "Detectando SO..."
  12. OS=$(uname -s)
  13. if [ $OS = "Linux" ]; then
  14. OS="GNU/Linux"
  15. if [ -f /etc/os-release ]; then
  16. DIST=$(grep ^NAME= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  17. REV=$(grep ^VERSION= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  18. ID_LIKE=$(grep ^ID_LIKE= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  19. for i in $ID_LIKE; do
  20. #printf "$i\n"
  21. case $i in
  22. debian|ubuntu)
  23. debianOS=true
  24. break
  25. ;;
  26. rhel|fedora)
  27. rhelOS=true
  28. break
  29. ;;
  30. *)
  31. debianOS=false
  32. rhelOS=false
  33. ;;
  34. esac
  35. done
  36. elif [ -f /etc/debian-version ]; then
  37. # Familia Debian (Debian, Ubuntu, Linux Mint, ...)
  38. DIST="Debian"
  39. REV=""
  40. ID_LIKE="debian"
  41. debianOS=true
  42. elif [ -f /etc/redhat-release ]; then
  43. # Familia Red-Hat (RHEL, Fedora, CentOS, ...)
  44. DIST="Red-Hat"
  45. REV=""
  46. ID_LIKE="rhel"
  47. rhelOS=true
  48. else
  49. # Other Linux (No Soportado)
  50. DIST=""
  51. REV=""
  52. ID_LIKE=""
  53. fi
  54. else
  55. # UNIX, OS X, ... (No Soportado)
  56. DIST=$OS
  57. REV=""
  58. fi
  59. #printf " $OS $DIST $REV\n"
  60. HDInfo=$(df -h | head -1)"\n"$(df -h | grep ^/dev/sd)"\n"$(df -h | grep ^/dev/mapper)
  61. }
  62. comprobarRoot() {
  63. if [ $(id -u) -ne 0 ]; then
  64. printf "ERROR:\tEs necesario ser root ('sudo $0').\n"
  65. exit 1
  66. fi
  67. }
  68. comprobarDependencias() {
  69. # Comprobamos whiptail
  70. which whiptail > /dev/null 2>&1
  71. if [ $? -ne 0 ];then
  72. printf "ERROR:\t'whiptail' no disponible.\n"
  73. exit 1
  74. fi
  75. # Comprobamos hostnamectl
  76. which hostnamectl > /dev/null 2>&1
  77. if [ $? -ne 0 ];then
  78. printf "ERROR:\t'hostnamectl' no disponible.\n"
  79. exit 1
  80. fi
  81. if [ $debianOS = true ];then
  82. # Comprobamos apt-get
  83. which apt-get > /dev/null 2>&1
  84. if [ $? -ne 0 ]; then
  85. printf "ERROR:\t'apt-get' no está disponible.\n"
  86. exit 1
  87. fi
  88. # Actualizamos base de datos del repositorio
  89. printf "Actualizando repositorio APT..."
  90. result=$(apt-get -q -y update)
  91. if [ $? -ne 0 ]; then
  92. printf "\nERROR:\tImposible actualizar repositorio.\n"
  93. printf "Detalles:\n$result\n"
  94. exit 1
  95. fi
  96. printf " OK.\n"
  97. # Comprobamos Firewall (ufw)
  98. which ufw > /dev/null 2>&1
  99. if [ $? -ne 0 ]; then
  100. printf "ERROR:\t'ufw' no disponible.\n"
  101. exit 1
  102. fi
  103. fi
  104. if [ $rhelOS = true ]; then
  105. # Comprobamos yum
  106. which yum > /dev/null 2>&1
  107. if [ $? -ne 0 ]; then
  108. printf "ERROR:\t'yum' no está disponible.\n"
  109. exit 1
  110. fi
  111. # Actualizamos base de datos del repositorio
  112. printf "Actualizando repositorio YUM..."
  113. result=$(yum -y makecache 2>&1)
  114. if [ $? -ne 0 ]; then
  115. printf "\nERROR:\tImposible actualizar repositorio.\n"
  116. printf "Detalles:\n$result\n"
  117. exit 1
  118. fi
  119. printf " OK.\n"
  120. # Comprobamos Firewall (firewall-cmd)
  121. which firewall-cmd > /dev/null 2>&1
  122. if [ $? -ne 0 ]; then
  123. printf "ERROR:\t'firewall-cmd' no disponible.\n"
  124. exit 1
  125. fi
  126. fi
  127. }
  128. inicializarVariables() {
  129. debianOS=false
  130. rhelOS=false
  131. apacheOn=false
  132. nginxOn=false
  133. mySQLOn=false
  134. mariaDBOn=false
  135. phpOn=false
  136. mediaWikiOn=false
  137. moodleOn=false
  138. actualizacionesOn=false
  139. }
  140. instalacionExpress() {
  141. apacheOn=true
  142. mariaDBOn=true
  143. phpOn=true
  144. mediaWikiOn=true
  145. moodleOn=true
  146. actualizacinesOn=true
  147. }
  148. comprobarHostname() {
  149. while [ -z $hostname ]; do
  150. hostname=$(whiptail --title "HOSTNAME" --inputbox "El nombre de dominio de este servidor es:\n"$(hostname)"\n\nQuieres cambiarlo por otro?" --ok-button "Cambiar" --cancel-button "No Cambiar" 20 70 3>&1 1>&2 2>&3)
  151. if [ $? -eq 0 ] && [ ! -z $hostname ]; then
  152. hostnamectl set-hostname $hostname
  153. else
  154. hostname=$(hostname)
  155. fi
  156. done
  157. #printf "\nHostname: $hostname\n"
  158. }
  159. mostrarBienvenida() {
  160. if [ $debianOS = false ] && [ $rhelOS = false ]; then
  161. whiptail --title "ERROR S.O. NO SOPORTADO" --msgbox "Este script automatiza la creación de una web MediaWiki SOLO para distribuciones Linux de la familia Debian (Ubuntu, Linux Mint, ...) y de la familia Red-Hat (CentOS, Fedora, ...).\n\nInformación del sistema:\nOS: $OS $DIST $REV\n$HDInfo" --ok-button "Salir" 20 70
  162. exit 1
  163. fi
  164. whiptail --title "INSTALACION MEDIAWIKI" --yesno "Este script automatiza completamente la instalación de una wiki.\nPara ello instala un servidor LAMP, el software MediaWiki y lo configura todo.\n\nInformación del sistema:\nOS: $OS $DIST $REV\n$HDInfo" --yes-button "Continuar" --no-button "Salir" 20 70
  165. if [ $? -ne 0 ]; then
  166. printf "ERROR:\tInstalación interrumpida por el usuario.\n"
  167. exit 2
  168. fi
  169. }
  170. mostrarComponentes() {
  171. componentes=$(whiptail --title "INSTALACION" --checklist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge los componentes que quieres instalar:" 20 70 7 \
  172. "WebServer" "Instalar servidor web http/https" ON \
  173. "Database" "Instalar una base de datos SQL" ON \
  174. "PHP" "Instala PHP7" ON \
  175. "SSL/TLS" "Instalar certificados para activar HTTPS" ON \
  176. "MediaWiki" "Instalar wiki con MediaWiki" ON \
  177. "Moodle" "Instalar campus virtual con Moodle" ON \
  178. "Actualizaciones" "Programar actualizaciones automáticas" ON \
  179. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  180. if [ $? -ne 0 ]; then
  181. printf "ERROR:\tInstalación interrumpida por el usuario.\n"
  182. exit 2
  183. fi
  184. # Mejora: autodetección de componentes ya instalados
  185. for i in $componentes; do
  186. case $i in
  187. \"WebServer\")
  188. mostrarWebServer
  189. ;;
  190. \"Database\")
  191. mostrarDatabase
  192. ;;
  193. \"PHP\")
  194. phpOn=true
  195. ;;
  196. \"SSL/TLS\")
  197. # 2 Opciones: Let's Encrypt o Autofirmado
  198. ;;
  199. \"MediaWiki\")
  200. mediaWikiOn=true
  201. ;;
  202. \"Moodle\")
  203. moodleOn=true
  204. ;;
  205. \"Actualizaciones\")
  206. actualizacionesOn=true
  207. ;;
  208. *)
  209. printf "ERROR:\tError interno (selección de componentes).\n"
  210. exit 1
  211. ;;
  212. esac
  213. done
  214. }
  215. mostrarWebServer() {
  216. webServer=$(whiptail --title "SERVIDOR WEB" --radiolist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge el servidor web que quieres usar:" 20 70 2 \
  217. "Apache" "Instalar el servidor web Apache2" ON \
  218. "Nginx" "Instalar el servidor web Nginx" OFF \
  219. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  220. if [ $? -ne 0 ]; then
  221. printf "ERROR:\tInstalación interrumpida por el usuario.\n"
  222. exit 2
  223. fi
  224. # Preguntar otras opciones de configuración
  225. comprobarHostname
  226. case $webServer in
  227. Apache)
  228. apacheOn=true
  229. ;;
  230. Nginx)
  231. nginxOn=true
  232. ;;
  233. *)
  234. printf "ERROR:\tError interno (selección de web server).\n"
  235. exit 1
  236. ;;
  237. esac
  238. }
  239. instalarApache() {
  240. if [ $debianOS = true ];then
  241. result=$(apt-get -q -y install apache2 2>&1)
  242. if [ $? -ne 0 ]; then
  243. printf "\nERROR:\tError al instalar Apache2.\n"
  244. printf "Detalles:\n$result\n"
  245. exit 1
  246. fi
  247. elif [ $rhelOS = true ]; then
  248. result=$(yum -y install httpd 2>&1)
  249. if [ $? -ne 0 ]; then
  250. printf "\nERROR:\tError al instalar Apache2.\n"
  251. printf "Detalles:\n$result\n"
  252. exit 1
  253. fi
  254. else
  255. printf "\nERROR:\tError interno (instalación Apache2).\n"
  256. exit 1
  257. fi
  258. }
  259. instalarNginx() {
  260. if [ $debianOS = true ];then
  261. result=$(apt-get -q -y install nginx 2>&1)
  262. if [ $? -ne 0 ]; then
  263. printf "\nERROR:\tError al instalar Nginx.\n"
  264. printf "Detalles:\n$result\n"
  265. exit 1
  266. fi
  267. elif [ $rhelOS = true ]; then
  268. # Hay que instalar primero otro repositorio
  269. result=$(yum -y install epel-release)
  270. if [ $? -ne 0 ]; then
  271. printf "\nERROR:\tError al intalar repositorio 'epel-release'.\n"
  272. printf "Detalles:\n$result\n"
  273. exit 1
  274. fi
  275. result=$(yum -y install nginx 2>&1)
  276. if [ $? -ne 0 ]; then
  277. printf "\nERROR:\tError al instalar Nginx.\n"
  278. printf "Detalles:\n$result\n"
  279. exit 1
  280. fi
  281. else
  282. printf "\nERROR:\tError interno (instalación Nginx).\n"
  283. exit 1
  284. fi
  285. }
  286. mostrarDatabase() {
  287. if [ $debianOS = true ]; then
  288. database=$(whiptail --title "BASE DE DATOS" --radiolist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge la base de datos que quieres usar:" 20 70 2 \
  289. "MySQL" "Instalar la base de datos MySQL (no uso comercial)" ON \
  290. "MariaDB" "Instalar la base de datos MariaDB (fork de MySQL)" OFF \
  291. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  292. if [ $? -ne 0 ]; then
  293. printf "ERROR:\tInstalación interrumpida por el usuario.\n"
  294. exit 2
  295. fi
  296. # Preguntar otras opciones de configuración
  297. case $database in
  298. MySQL)
  299. mySQLOn=true
  300. ;;
  301. MariaDB)
  302. mariaDBOn=true
  303. ;;
  304. *)
  305. printf "ERROR:\tError interno (selección de base de datos).\n"
  306. exit 1
  307. ;;
  308. esac
  309. elif [ $rhelOS = true ]; then
  310. whiptail --title "BASE DE DATOS" --yesno "Para su distribucion $OS $DIST $REV, sólo está disponible la base de datos MariaDB." --yes-button "Continuar" --no-button "Salir" 20 70
  311. if [ $? -ne 0 ]; then
  312. printf "ERROR:\tInstalación interrumpida por el usuario.\n"
  313. exit 2
  314. fi
  315. mariaDBOn=true
  316. else
  317. printf "ERROR:\tError interno (instalación Base de Datos).\n"
  318. exit 1
  319. fi
  320. }
  321. instalarMySQL() {
  322. if [ $debianOS = true ];then
  323. result=$(apt-get -q -y install mysql-server mysql-client 2>&1)
  324. if [ $? -ne 0 ]; then
  325. printf "\nERROR:\tError al instalar MySQL.\n"
  326. printf "Detalles:\n$result\n"
  327. exit 1
  328. fi
  329. elif [ $rhelOS = true ]; then
  330. # MySQL no disponible en RHEL. 2 opciones:
  331. # 1) Instalar un repositorio adicional
  332. # 2) No instalar MySQL en distribuciones RHEL
  333. printf "\nERROR:\tRHEL no incluye MySQL en sus repositorios.\n"
  334. exit 1
  335. else
  336. printf "\nERROR:\tError interno (instalación MySQL).\n"
  337. exit 1
  338. fi
  339. }
  340. instalarMariaDB() {
  341. if [ $debianOS = true ];then
  342. result=$(apt-get -q -y install mariadb-server mariadb-client 2>&1)
  343. if [ $? -ne 0 ]; then
  344. printf "\nERROR:\tError al instalar MariaDB.\n"
  345. printf "Detalles:\n$result\n"
  346. exit 1
  347. fi
  348. elif [ $rhelOS = true ]; then
  349. result=$(yum -y install mariadb-server 2>&1)
  350. if [ $? -ne 0 ]; then
  351. printf "\nERROR:\tError al instalar MariaDB.\n"
  352. printf "Detalles:\n$result\n"
  353. exit 1
  354. fi
  355. else
  356. printf "\nERROR:\tError interno (instalación MariaDB).\n"
  357. exit 1
  358. fi
  359. }
  360. # Comprobación del sistema e inicialización
  361. comprobarRoot
  362. inicializarVariables
  363. OSInfo
  364. comprobarDependencias
  365. # Bienvenida
  366. mostrarBienvenida
  367. # Mejora: instalación express vs instalación avanzada
  368. # Selección de componentes
  369. mostrarComponentes
  370. # Pre-configuración
  371. # Habilitar cortafuegos -> PROBLEMA: se corta la conexión ssh
  372. # Instalación
  373. # FALTA: whiptail --gauge -> Más bonito
  374. # Servidor Web
  375. if [ $apacheOn = true ]; then
  376. printf "Instalando Web Server Apache..."
  377. #instalarApache
  378. printf " OK.\n"
  379. elif [ $nginxOn = true ]; then
  380. printf "Instalando Web Server Nginx..."
  381. #instalarNginx
  382. printf " OK.\n"
  383. else
  384. printf "ERROR:\tError interno (instalación Web Server).\n"
  385. exit 1
  386. fi
  387. # Base de Datos
  388. if [ $mySQLOn = true ]; then
  389. printf "Instalando Base de Datos MySQL..."
  390. #instalarMySQL
  391. printf " OK.\n"
  392. elif [ $mariaDBOn = true ]; then
  393. printf "Instalando Base de Datos MariaDB..."
  394. #instalarMariaDB
  395. printf " OK.\n"
  396. else
  397. printf "ERROR:\tError interno (instalación Base de Datos).\n"
  398. exit 1
  399. fi
  400. # PHP
  401. if [ $phpOn = true ]; then
  402. printf "Instalando PHP-7..."
  403. printf " OK.\n"
  404. fi
  405. # SSL/TLS
  406. # Falta por implementar
  407. # MediaWiki
  408. if [ $mediaWikiOn = true ]; then
  409. printf "Instalando MediaWiki..."
  410. printf " OK.\n"
  411. fi
  412. # Moodle
  413. if [ $moodleOn = true ]; then
  414. printf "Instalando Moodle..."
  415. printf " OK.\n"
  416. fi
  417. # Configuración
  418. # Configuración Apache
  419. # Virtual Hosts
  420. # Configuración Database
  421. # Configuración Segura
  422. # Configuración PHP
  423. # cgi.fix_pathinfo=0
  424. # Configurar máximo de subida de archivos
  425. # Configuración MediWiki
  426. # Configuración Moodle
  427. # Arrancar y habilitar todos los servicios (SystemD, Service o SystemV)
  428. # Añadir reglas del cortafuegos
  429. # Configuración SSL/TLS
  430. # Generar certificados
  431. # Configurar certificados
  432. # Configurar actualizaciones
  433. if [ $actualizacionesOn = true ]; then
  434. printf "Configurando actualizaciones automáticas..."
  435. printf " OK.\n"
  436. fi
  437. # Autodestrucción
  438. {
  439. for i in $(seq 0 5 50); do
  440. sleep 0.1
  441. echo $i
  442. done
  443. } | whiptail --gauge "Autodestrucción..." 7 70 0
  444. {
  445. for i in $(seq 50 5 100); do
  446. sleep 0.1
  447. echo $i
  448. done
  449. } | whiptail --gauge "Autopulverización..." 7 70 50